#!/usr/bin/perl

$CBData = "CBData.csv";


#--- Please don't edit below this line if your are not familiar with Perl --#


read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
if (length($buffer) < 5) {
$buffer = $ENV{QUERY_STRING};
}

@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
 {
($name, $value) = split(/=/, $pair);
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$value =~ s/[\;\|\\ ]/ /ig;
push(@values,$value); push(@names,$name);
$FORM{$name} = $value;
}

# Get Variables.

$SearchWord = $FORM{'k'};
$ExactMatch = $FORM{'e'};
$DescSearch = $FORM{'s'};

# Other variables.

$counter = 0;
$delimiter = '\|';
$spacer = "-";
$SW = lc($SearchWord);
$Space = " ";
$NoOfKeywords = 1;  # initialize this variable


## Print Statement
print "Content-type: text/html\n\n";


if ($ENV{'REQUEST_METHOD'} ne 'POST')
{

print <<EOF;

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<title>ClickBank(TM) Products Database - Search Utility</title>
</head>

<body bgcolor="#F5F5F5">
<form method="POST" action="search.cgi" target="_blank">
<p align="center"><font color="#000080"><b><font face="Verdana,Arial,Helvetica" size="4">ClickBank</font></b><font face="Verdana,Arial,Helvetica" size="1"><sup>(TM)</sup></font><b><font face="Verdana,Arial,Helvetica" size="4">
Product Database</font></b></font></p>
<p align="center"><b><u><font face="Verdana,Arial,Helvetica" size="3">Search
Utility</font></u></b></p>

<div align="center">
  <center>
  <table border="2" width="513" cellspacing="0" cellpadding="0" bgcolor="#FFFFFF">
    <tr>
      <td width="606">
        
        
        <div align="center">
  <center>
  <table border="0" width="519">
    <tr>
      <td width="215" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Enter
        Keyword(s):</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left" width="286"><input type="text" name="k" size="36" style="font-family: Verdana, Arial, Helvetica; font-size: 10pt"></td>
    </tr>
    <tr>
      <td width="215" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Search in:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left" width="286"><select size="1" name="s" style="font-family: Verdana, Arial, Helvetica; font-size: 10pt">
          <option selected value="0">Title only</option>
          <option value="1">Title &amp; Description</option>
          <option value="2">ClickBank ID</option>
        </select></td>
    </tr>
    <tr>
      <td width="215" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Exact
        Match:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left" width="286"><input type="checkbox" name="e" value="1" checked></td>
    </tr>
    <tr>
      <td width="509" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="center" colspan="2"><input type="submit" value="Search" name="B1" style="font-family: Verdana, Arial, Helvetica; font-size: 10pt; font-weight: bold"></td>
    </tr>
  </table>
  </center>
</div>

 </td>
    </tr>
  </table>
  </center>
</div>
<p>&nbsp;</p>
</form>
</body>

</html>


EOF

exit;
}


# If more than one keyword entered and Exact Match is not checked
if ( index($SW, $Space) != -1 && $ExactMatch != 1)
{
 $NoOfKeywords = 2;

 $SecondwordPosition = index($SW, $Space);
 $Firstword = substr($SW, 0,$SecondwordPosition);
 $Secondword = substr($SW, ($SecondwordPosition+1));

 # if more than two keywords found...
 if ( index($Secondword, $Space) != -1)
	{
      $NoOfKeywords = 3;
	  
	  $Lastpart = $Secondword;
	  $ThirdwordPosition = index($Secondword, $Space);
      $Secondword = substr($Secondword, 0,$ThirdwordPosition);
      $Thirdword = substr($Lastpart, ($ThirdwordPosition+1));
	}
}

open(PRODUCTS, "<$CBData") || die "$CBData could not be opened";
# Place each line into an array
my @product_list = <PRODUCTS>;
close(PRODUCTS);

print <<EOF;

<html>
<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<title>Search Result for "$SearchWord"</title>
</head>

<body bgcolor="#F5F5F5">

<p align="center"><font color="#000080"><b><font face="Verdana,Arial,Helvetica" size="4">ClickBank</font></b><font face="Verdana,Arial,Helvetica" size="1"><sup>(TM)</sup></font><b><font face="Verdana,Arial,Helvetica" size="4">
Product Database</font></b></font></p>
<p align="center"><b><u><font face="Verdana,Arial,Helvetica" size="3">Search Utility</font></u></b></p>

  <blockquote>
    <div align="center">
      <center>
  <table border="2" width="493" cellspacing="0" cellpadding="0">
    <tr>
      <td width="134" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Search for:</b> </font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 5" valign="top" align="left" width="341"><font color="#0000FF" face="Verdana,Arial,Helvetica" size="2"><b><i>&nbsp;$SearchWord</i></b></font></td>
    </tr>
  </table>
      </center>
    </div>
  </blockquote>


EOF

# If search for CB ID
if ($DescSearch == 2) {

#-----
foreach(@product_list)
 {
     my ($mrank,$murl,$mmaincat,$msubcat,$mtitle,$mid,$mcommission,$mdesc) = split($delimiter,$_,8);
	 
	 $thisID = lc($mid);

          if ( index($thisID, $SW) != -1 )
	      {

$counter = $counter + 1;

print <<EOF;

<div align="center">
  <center>
  <table border="2" width="650" cellspacing="0" cellpadding="0" bgcolor="#FFFFFF">
    <tr>
      <td width="606">
  <div align="center">
  <center>
  <table border="0" width="645">
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Serial
        No:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$counter</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Product Title:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2"><a href="$murl" target="_blank"><b><font color="#000000">$mtitle</font></b></a></font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Description:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mdesc</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Category:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mmaincat - $msubcat</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>CB Rank:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mrank</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>CB ID:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mid</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Commission:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mcommission</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Affiliate
        Link:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><a href="$murl" target="_blank"><font face="Verdana,Arial,Helvetica" size="2">$murl</font></a></td>
    </tr>
  </table>
  </center>
</div>
      </td>
    </tr>
  </table>
  </center>
</div>
<br>

EOF

		  }
	  }

print <<EOF;

<center>
<font color="#000000" face="Verdana,Arial,Helvetica" size="2">
<b>Number of matches found: <u>$counter</u></b>
</font>
</center>

EOF

exit;

#-----
}


foreach(@product_list)
 {
     my ($mrank,$murl,$mmaincat,$msubcat,$mtitle,$mid,$mcommission,$mdesc) = split($delimiter,$_,8);
	 
	 $thistitle = lc($mtitle);
	 $thisdesc = lc($mdesc);
	 $bothstring = $thistitle." ".$thisdesc;
	 
     if ($DescSearch ==1) 
	 {
     	 $querystring = $bothstring;
     }
	 else
     {
		 $querystring = $thistitle;
	 }

     if ($NoOfKeywords ==1) 
	  {
          if ( index($querystring, $SW) != -1 )
	      {
#------------------------
$counter = $counter + 1;

print <<EOF;

<div align="center">
  <center>
  <table border="2" width="650" cellspacing="0" cellpadding="0" bgcolor="#FFFFFF">
    <tr>
      <td width="606">
  <div align="center">
  <center>
  <table border="0" width="645">
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Serial
        No:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$counter</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Product Title:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2"><a href="$murl" target="_blank"><b><font color="#000000">$mtitle</font></b></a></font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Description:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mdesc</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Category:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mmaincat - $msubcat</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>CB Rank:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mrank</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>CB ID:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mid</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Commission:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mcommission</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Affiliate
        Link:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><a href="$murl" target="_blank"><font face="Verdana,Arial,Helvetica" size="2">$murl</font></a></td>
    </tr>
  </table>
  </center>
</div>
      </td>
    </tr>
  </table>
  </center>
</div>
<br>

EOF

#-------------------------
		  }
	  }

	 if ($NoOfKeywords ==2) 
	  {
          if ( index($querystring, $Firstword) != -1  || index($querystring, $Secondword) != -1)
	      {
#------------------------
$counter = $counter + 1;

print <<EOF;

<div align="center">
  <center>
  <table border="2" width="650" cellspacing="0" cellpadding="0" bgcolor="#FFFFFF">
    <tr>
      <td width="606">
  <div align="center">
  <center>
  <table border="0" width="645">
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Serial
        No:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$counter</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Product Title:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2"><a href="$murl" target="_blank"><b><font color="#000000">$mtitle</font></b></a></font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Description:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mdesc</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Category:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mmaincat - $msubcat</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>CB Rank:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mrank</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>CB ID:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mid</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Commission:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mcommission</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Affiliate
        Link:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><a href="$murl" target="_blank"><font face="Verdana,Arial,Helvetica" size="2">$murl</font></a></td>
    </tr>
  </table>
  </center>
</div>
      </td>
    </tr>
  </table>
  </center>
</div>
<br>

EOF

#-------------------------
          }
	  }

	 if ($NoOfKeywords ==3) 
	  {
          if ( index($querystring, $Firstword) != -1  || index($querystring, $Secondword) != -1  || index($querystring, $Thirdword) != -1)
	      {
#------------------------
$counter = $counter + 1;

print <<EOF;

<div align="center">
  <center>
  <table border="2" width="650" cellspacing="0" cellpadding="0" bgcolor="#FFFFFF">
    <tr>
      <td width="606">
  <div align="center">
  <center>
  <table border="0" width="645">
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Serial
        No:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$counter</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Product Title:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2"><a href="$murl" target="_blank"><b><font color="#000000">$mtitle</font></b></a></font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Description:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mdesc</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Category:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mmaincat - $msubcat</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>CB Rank:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mrank</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>CB ID:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mid</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Commission:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><font face="Verdana,Arial,Helvetica" size="2">$mcommission</font></td>
    </tr>
    <tr>
      <td width="133" bgcolor="#D2D2D2" style="padding-right: 3" valign="top" align="right"><font face="Verdana,Arial,Helvetica" size="2"><b>Affiliate
        Link:</b></font></td>
      <td bgcolor="#EFEFEF" style="padding-left: 3" valign="top" align="left"><a href="$murl" target="_blank"><font face="Verdana,Arial,Helvetica" size="2">$murl</font></a></td>
    </tr>
  </table>
  </center>
</div>
      </td>
    </tr>
  </table>
  </center>
</div>
<br>

EOF

#-------------------------
          }
	  }
 }

print <<EOF;

<center>
<font color="#000000" face="Verdana,Arial,Helvetica" size="2">
<b>Number of matches found: <u>$counter</u></b>
</font>
</center>

EOF

exit;
